# - Looking for the SUNSET installation
# - The executable tool is sunset.exe
###############################################
###    Author : F. Gaudier (CEA)
###    Date   : 2010-07-12 11:44:43
### Objective : check the installation of the "sunset" tool (IRSN : possibility)
###             This module tries to find the SUNSET tool (IRSN tool) for the NURISP project.
###############################################


MESSAGE(STATUS "Looking for Sunset...")

SET(SUNSET_FOUND FALSE)

FIND_PROGRAM(SUNSET_EXECUTABLE NAMES sunset.exe PATHS PATH)

IF (${SUNSET_EXECUTABLE} MATCHES "SUNSET_EXECUTABLE-NOTFOUND")
  MESSAGE(STATUS "Looking for Sunset... - not installed in the searchpath (The RaFu sampling will NOT be installed).")
ELSE (${SUNSET_EXECUTABLE} MATCHES "SUNSET_EXECUTABLE-NOTFOUND")
  MESSAGE(STATUS "Looking for Sunset... - installed (The RaFu sampling will be installed).")
  SET(SUNSET_FOUND TRUE)
ENDIF (${SUNSET_EXECUTABLE} MATCHES "SUNSET_EXECUTABLE-NOTFOUND")

# End Of FindSUNSET.cmake