
#-------------------------------------------------------------------------
# OPT++ installation through archive
#-------------------------------------------------------------------------

if(WIN32)
    SET(7ZIP_EXEC "C:/Program Files/7-Zip/7z.exe")
    set(OPT_ARCHIVE_NAME_EXT "-UranieWindowsPatched-20171220")
else(WIN32)
    set(OPT_ARCHIVE_NAME_EXT "-UranieLinuxPatched-20170223")
endif(WIN32)

SET(OPT_DIR "optpp-2.4")
FILE(TO_NATIVE_PATH "${CMAKE_SOURCE_DIR}/tools/${OPT_DIR}${OPT_ARCHIVE_NAME_EXT}.tar.gz" OPT_ARCHIVE)
FILE(TO_NATIVE_PATH "${CMAKE_BINARY_DIR}/OPT++/BUILD" OPT_BUILD_DIR)
FILE(TO_NATIVE_PATH "${OPT_BUILD_DIR}/${OPT_DIR}${OPT_ARCHIVE_NAME_EXT}" OPT_BUILD_ARCHIVE_DIR)
FILE(TO_NATIVE_PATH "${CMAKE_INSTALL_PREFIX}/OPT++" OPT_INSTALL_DIR)
FILE(TO_NATIVE_PATH "${OPT_INSTALL_DIR}/${OPT_DIR}/lib" OPTPP_LIB_DIR)
FILE(TO_NATIVE_PATH "${OPT_INSTALL_DIR}/${OPT_DIR}/include" OPTPP_INCLUDE_DIR)


if(WITH-OPT++ STREQUAL "ON")
    message(STATUS "Untar OPT++ archive")
    exec_program(${CMAKE_COMMAND} ARGS -E  make_directory ${OPT_BUILD_ARCHIVE_DIR} OUTPUT_VARIABLE BLA)
    exec_program(${CMAKE_COMMAND} ARGS -E  make_directory ${OPT_INSTALL_DIR} OUTPUT_VARIABLE BLA)
    if(WIN32)
        exec_program(${CMAKE_COMMAND} ARGS -E chdir ${CMAKE_SOURCE_DIR}/tools ${7ZIP_EXEC} x ${OPT_ARCHIVE} -o${OPT_BUILD_DIR} -y OUTPUT_VARIABLE BLA)
        exec_program(${CMAKE_COMMAND} ARGS -E chdir ${CMAKE_SOURCE_DIR}/tools ${7ZIP_EXEC} x "${OPT_BUILD_DIR}/${OPT_DIR}${OPT_ARCHIVE_NAME_EXT}.tar" -o${OPT_BUILD_DIR} -y OUTPUT_VARIABLE BLA)
    else(WIN32)
        exec_program(${CMAKE_COMMAND} ARGS -E chdir ${CMAKE_SOURCE_DIR}/tools tar zxf ${OPT_ARCHIVE} -C ${OPT_BUILD_ARCHIVE_DIR} OUTPUT_VARIABLE BLA)
    endif(WIN32)
    message(STATUS "** Configuring OPT++...")
    if(WIN32)
        exec_program(${CMAKE_COMMAND} ARGS -E chdir "${OPT_BUILD_ARCHIVE_DIR}" cmake . -A ${CMAKE_GENERATOR_PLATFORM} -D--enable-WIN32-DEBUG="OFF" -DCMAKE_INSTALL_PREFIX=${OPT_INSTALL_DIR}/${OPT_DIR} OUTPUT_VARIABLE BLA)
    else(WIN32)
        exec_program(${CMAKE_COMMAND} ARGS -E chdir "${OPT_BUILD_ARCHIVE_DIR}/${OPT_DIR}" ./configure ARGS --prefix=${OPT_INSTALL_DIR}/${OPT_DIR} --enable-shared --disable-static --without-blas OUTPUT_VARIABLE BLA)
    endif(WIN32)
    message(STATUS "**  Done")
    if(WIN32)
        message(STATUS "** Compiling and installing OPT++")
        exec_program(${CMAKE_COMMAND} ARGS -E chdir "${OPT_BUILD_ARCHIVE_DIR}" cmake --build . --config Release --target install OUTPUT_VARIABLE BLA)
    else(WIN32)
        message(STATUS "** Compiling OPT++")
        exec_program(sed ARGS -i s%"//\#define SETUP_C_SUBSCRIPTS"%"\#define SETUP_C_SUBSCRIPTS"% ${OPT_BUILD_ARCHIVE_DIR}/${OPT_DIR}/newmat11/include.h OUTPUT_VARIABLE BLA)
        exec_program(sed ARGS -i s%"\#define SimulateExceptions"%"//\#define SimulateExceptions"% ${OPT_BUILD_ARCHIVE_DIR}/${OPT_DIR}/newmat11/include.h OUTPUT_VARIABLE BLA)    
        exec_program(sed ARGS -i s%"//\#define UseExceptions"%"\#define UseExceptions"% ${OPT_BUILD_ARCHIVE_DIR}/${OPT_DIR}/newmat11/include.h OUTPUT_VARIABLE BLA)
        exec_program(sed ARGS -i s%"\#define TypeDefException"%"//\#define TypeDefException"% ${OPT_BUILD_ARCHIVE_DIR}/${OPT_DIR}/newmat11/include.h OUTPUT_VARIABLE BLA)   
        exec_program(${CMAKE_COMMAND} ARGS -E chdir ${OPT_BUILD_ARCHIVE_DIR}/${OPT_DIR} make OUTPUT_VARIABLE BLA)
    endif(WIN32)
    message(STATUS "**  Done")
    if(UNIX)
        message(STATUS "** Installing OPT++...")
        exec_program(${CMAKE_COMMAND} ARGS -E chdir ${OPT_BUILD_ARCHIVE_DIR}/${OPT_DIR} make install OUTPUT_VARIABLE BLA)
        exec_program(cp ARGS ${OPT_BUILD_ARCHIVE_DIR}/${OPT_DIR}/newmat11/newmat*.h ${OPTPP_INCLUDE_DIR} OUTPUT_VARIABLE BLA)    
        exec_program(cp ARGS ${OPT_BUILD_ARCHIVE_DIR}/${OPT_DIR}/newmat11/precisio.h ${OPTPP_INCLUDE_DIR} OUTPUT_VARIABLE BLA)   
        exec_program(cp ARGS ${OPT_BUILD_ARCHIVE_DIR}/${OPT_DIR}/newmat11/myexcept.h ${OPTPP_INCLUDE_DIR} OUTPUT_VARIABLE BLA)
        exec_program(cp ARGS ${OPT_BUILD_ARCHIVE_DIR}/${OPT_DIR}/newmat11/include.h  ${OPTPP_INCLUDE_DIR} OUTPUT_VARIABLE BLA)    
        exec_program(cp ARGS ${OPT_BUILD_ARCHIVE_DIR}/${OPT_DIR}/lib/.libs/libopt.so* ${OPTPP_LIB_DIR} OUTPUT_VARIABLE BLA)
        exec_program(cp ARGS ${OPT_BUILD_ARCHIVE_DIR}/${OPT_DIR}/lib/.libs/libnewmat.so* ${OPTPP_LIB_DIR} OUTPUT_VARIABLE BLA)
        message(STATUS "**  Done")
    endif(UNIX)
    

    #Sets environment variables
    if(WIN32)
        set(ENV{LD_LIBRARY_PATH} "${OPTPP_LIB_DIR};$ENV{LD_LIBRARY_PATH}")   
    else(WIN32)
        set(ENV{LD_LIBRARY_PATH} "${OPTPP_LIB_DIR}:$ENV{LD_LIBRARY_PATH}")
    endif(WIN32)
endif(WITH-OPT++ STREQUAL "ON")
#-------------------------------------------------------------------------
