//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2023 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision$
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TestTAttributeFormula.cxx
 \author C�dric Forgues (C.S.) <uranietm@cea.fr>
 \date   $Date$
 
 \brief  Fichier de test de la classe URANIE::DataServer::TAttributeFormula
 
 Cr�e le : mar avri 26 10:00:00 2010

 \par Modifications
 \li Cedric Forgues (C.S.) 2011/01/07: correction des delete dproba;
 \li Cedric Forgues (C.S.) 2010/04/26
 Ajout des m�thodes
 // *****************************************************************************

 */

#include "TestTAttributeFormula.h"
#include "TString.h"

#include <iostream>
using namespace std;

TAttributeFormulaTest::TAttributeFormulaTest()
{
}

TAttributeFormulaTest::~TAttributeFormulaTest()
{
}

void TAttributeFormulaTest::setUp()
{
    taf = new URANIE::DataServer::TAttributeFormula("Attribut", "x+y");
}

void TAttributeFormulaTest::tearDown()
{
    delete taf;
    taf = NULL;
}

void TAttributeFormulaTest::testGetSetFormula()
{
    CPPUNIT_ASSERT(taf->getFormula() == "x+y");
    taf->setFormula("x*x");
    CPPUNIT_ASSERT(taf->getFormula() == "x*x");
}

/////////////////////////////////////////////////////////////////
////////////////////      Exceptions         ////////////////////
/////////////////////////////////////////////////////////////////

void TAttributeFormulaTest::throwExceptionNoFormula()
{
    CPPUNIT_ASSERT_THROW(new URANIE::DataServer::TAttributeFormula("Attribut"),
            URANIE::Exceptions::UErrorExceptions);
}
