//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2023 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision$
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TestTTemporalTree.h
 \author Fabrice Gaudier <fabrice.gaudier@cea.fr>
 \date   $Date$
 
 \brief  Fichier de test de la classe TestTTemporalTree.
 
 
 */
#ifndef CPPUNITEST_TTEMPORALTREE_H
#define CPPUNITEST_TTEMPORALTREE_H

// CPPUNIT
#include <cppunit/extensions/HelperMacros.h>
//#include <cppunit/portability/CppUnitDeque.h>
#include <cppunit/Test.h>
#include <cppunit/TestFailure.h>
#include <cppunit/TestResultCollector.h>

// Uranie
#include "TTemporalTree.h"
#include "TestTDataServer.h"

/*! \class TTemporalTreeTest
 * \brief Unit tests for TTemporalTree
 */
class TTemporalTreeTest: public CPPUNIT_NS::TestFixture
{
    CPPUNIT_TEST_SUITE (TTemporalTreeTest);

    CPPUNIT_TEST (testNPatterns);
    CPPUNIT_TEST (testWithXAttributes);


    CPPUNIT_TEST_SUITE_END();

public:
    /*!
     * \brief Constructor
     */
    TTemporalTreeTest();
    /*!
    * \brief Destructor
    */
    virtual ~TTemporalTreeTest();

    /** @name SetUp and TeadDown methods
     The two setUp and tearDown() methods.
     **/
    //@{
    /*!
     * \brief The setUp method
     */
    void setUp();
    /*!
     * \brief The tearDown method.
     */
    void tearDown();
    //@}

    //---------------------------------------------
    /** @name Unit Tests
     The list of unit test
     **/
    //@{
    //! Test the number of patterns
    void testNPatterns();
    //! Test with X attributes
    void testWithXAttributes();
    //@}

private:
    URANIE::DataServer::TDataServer *_tdsLevelE;
    URANIE::DataServer::TTemporalTree *_tttLevelE;
};

#endif  // CPPUNITEST_TTEMPORALTREE_H
