//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2023 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision$
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TestTUniformByPartsDistribution.h
 \author Fabrice Gaudier <fabrice.gaudier@cea.fr>
 \date   $Date$
 
 \brief  Test file of the class URANIE::DataServer::TUniformByPartsDistribution
 
 Created: 2009-12-08 09:14:10
 
 */
#ifndef CPPUNITEST_TUNIFORMBYPARTSDISTRIBUTION_H
#define CPPUNITEST_TUNIFORMBYPARTSDISTRIBUTION_H

//CPPUNIT
#include <cppunit/extensions/HelperMacros.h>
//#include <cppunit/portability/CppUnitDeque.h>
#include <cppunit/Test.h>
#include <cppunit/TestFailure.h>
#include <cppunit/TestResultCollector.h>

//URANIE
#include "TUniformByPartsDistribution.h"
#include "UExceptions.h"

class TUniformByPartsDistributionTest: public CPPUNIT_NS::TestFixture
{
    CPPUNIT_TEST_SUITE (TUniformByPartsDistributionTest);
    CPPUNIT_TEST (testDefaultLaw);
    CPPUNIT_TEST (throwExceptionWithBadMode);
    CPPUNIT_TEST (throwExceptionWithBadBoundaries);CPPUNIT_TEST_SUITE_END();

public:
    /*! Constructs a TUniformByPartsDistributionTest object.
     */
    TUniformByPartsDistributionTest();

    /// Destructor.
    virtual ~TUniformByPartsDistributionTest();

    void setUp();
    void tearDown();
    //---------------------------------------------
    /** @name Unit Tests
     The list of unit test
     **/
    //@{
    //! Test the default constructor
    void testDefaultLaw();

    //! Throws an exception when mode is not between defined bounds.
    void throwExceptionWithBadMode();

    //! Throws an exception when upper bound < lower bound.
    void throwExceptionWithBadBoundaries();

    //@}

private:
    URANIE::DataServer::TUniformByPartsDistribution *_dproba;
};

#endif  // CPPUNITEST_TUNIFORMBYPARTSDISTRIBUTION_H
