//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2023 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision$
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   ClassName.h
 \author Fabrice Gaudier <fabrice.gaudier@cea.fr>
 \date   DateName
 
 \brief Interface of the class URANIE::Launcher::ClassName
 
 */
/**
 
 * @class URANIE::Launcher::ClassName
 *
 * @brief Description of the class ClassName.
 *
 * To write by the developper.
 *
 */
#ifndef CLASSNAME_H
#define CLASSNAME_H

#include "iostream.h"

//ROOT
#include "Rtypes.h"

// Uranie
#include "Launcher.h"

namespace URANIE
{
namespace Launcher
{
class ClassName
{
private:
    Bool_t _blog;                          ///< Boolean for edit the log
public:
    //---------------------------------------------
    /** @name Constructor and Destructor
     **/
    //@{
    //! Default constructor
    ClassName();
    //! Default destructor
    virtual ~ClassName();
    //@}

    //---------------------------------------------
    /** @name Printing Log
     **/
    //@{
    void setLog()
    {
        _blog = kTRUE;
    }
    void unsetLog()
    {
        _blog = kFALSE;
    }
    void changeLog()
    {
        _blog = _blog ? kFALSE : kTRUE;
    }
    Bool_t getLog()
    {
        return _blog;
    }
    virtual void printLog(Option_t *option = "");
    //@}

    ClassDef(URANIE::Launcher::ClassName, ID_LAUNCHER)
    //Classe de
};

} // Fin du namespace Launcher
} // Fin du namespace URANIE
#endif
