       program levele
          
C
C       THE LEVELE MODEL.
C       
C       for the SIMLAB software
C-----------------------------------------------------------------------
C   INPUT:   
C		 levelE_input_with_values_rows.in
C
C	OUTPUTS:
C		 _output_levelE_withColumn_.dat
C        _output_levelE_withRow_.dat
C        _output_levelE_withKey_.dat
C
C-----------------------------------------------------------------------
C

C === Declarations ===
      IMPLICIT REAL (A-H,P-Z)
      
      INCLUDE 'par.h'
      INCLUDE 'cparam.h'                                                        
      INCLUDE 'cvaria.h' 
      INCLUDE 'cfast.h'
      include 'ctime.h'                                                      
      INCLUDE 'cspop.h'                                                            
      integer :: iostat,ok, dim

      DIMENSION VAR(MXNVAR),U(MXNRUN)
      CHARACTER(len=32)::inputFile
      CHARACTER(len=350)::MYT
      CHARACTER(len=350)::MYY
      CHARACTER(len=350)::MYZ
      CHARACTER(len=364)::MYT2
      CHARACTER(len=364)::MYY2
      CHARACTER(len=364)::MYZ2
      
      IOUT=MXNTIM

      DATA (TOUT(j), j=1,MXNTIM)  /
     *  2.000E04,  3.000E04,  4.000E04,  5.000E04,  6.000E04,  7.000E04,  
     *  8.000E04,  9.000E04,  1.000E05,  2.000E05,  3.000E05,  4.000E05,   
     *  5.000E05,  6.000E05,  7.000E05,  8.000E05,  9.000E05,  1.000E06,
     *  2.000E06,  3.000E06,  4.000E06,  5.000E06,  6.000E06,  7.000E06,   
     *  8.000E06,  9.000E06 /

      inputFile = 'levelE_input_with_values_rows.in'

C === Open Input sample file ===
      open(55,file=inputFile,status = 'old',iostat = ok)
      rewind(55)
      if(ok /= 0) then
          write(*,*) 'Error with input file: ',inputFile
          stop
      end if

      
C === Loop to count the number of lines of the file ===
      dim=0
      do while(ok == 0)
          read(55,*,iostat = ok)
          if (ok == 0) dim = dim + 1
      end do


C     === Preparation of the output files ===
      open(101,file='_output_levelE_withDataServer_.dat')
      open(77,file='_output_levelE_withColumn_.dat')
      open(88,file='_output_levelE_withRow_.dat')
      open(99,file='_output_levelE_withKey_.dat')
      open(96,file='_output_levelE_.xml')

c     --- Row ---
      write(101,'(A)') '#COLUMN_NAMES: tps | y | z'
      write(101,'(A)') '#COLUMN_TYPES: V | V | V'
      write(101,*)''

c     --- XML ---
      write(96,'(A)') '<?xml version="1.0" encoding="iso-8859-1"?>'
      write(96,'(A)') '<levele>'

      nrunmax=dim
      nvars=12

      rewind(55)          
      
C === Computation loop ===
      DO nrun=1,nrunmax                                                	 

c        read input variables
          read(55,*,iostat = ok)  (XVAR(NVAR),NVAR=1,nvars)

          if (ok.ne.0) then
              print *,'Impossible to read input file',inputFile
              stop
          end if

          CALL levele_model  !input ---> xvar(nvars)
C	                         !output  ---> UU matrix

c         --- DataServer ---
c     write(101,'(25(e13.7,a)1e13.7)') (TOUT(ITIME),",",ITIME=1,IOUT-1),TOUT(26)
          write(MYT,'(25(e13.7,a))') (TOUT(ITIME),",",ITIME=1,IOUT-1)
          write(MYT2,'(a,e13.7)') MYT,TOUT(IOUT)
       write(MYY,'(25(e13.7,a))') (UU(ITIME,3,NRUN),",",ITIME=1,IOUT-1)
          write(MYY2,'(a,e13.7)') MYY,UU(IOUT,3,NRUN)
      write(MYZ,'(25(e13.7,a))')(UU(ITIME,3,NRUN)**2,",",ITIME=1,IOUT-1)
          write(MYZ2,'(a,e13.7)') MYZ,UU(IOUT,3,NRUN)**2
          write(101,'(a a a)') MYT2,MYY2,MYZ2
          
c         --- Column ---
          write(77,'(26g15.7)') TOUT
          write(77,'(26g15.7)') (UU(ITIME,3,NRUN),ITIME=1,IOUT)
          write(77,'(26g15.7)') (UU(ITIME,3,NRUN)**2,ITIME=1,IOUT)

c         --- Row ---
          DO ITIME=1,IOUT
              write(88,'(3g15.7)') TOUT(ITIME),
     &                             UU(ITIME,3,NRUN),
     &                             UU(ITIME,3,NRUN)**2
          END DO

c         --- Key ---
          DO ITIME=1,IOUT
              write(99,'(a,g15.7)') 'time = ',TOUT(ITIME)
              write(99,'(a,g15.7)') 'y = ',UU(ITIME,3,NRUN)
              write(99,'(a,g15.7)') 'z = ',UU(ITIME,3,NRUN)**2
          END DO


c     --- XML ---
          write(96,'(A,I2,A)') '<times n="', IOUT, '" name="tps">'
          write(96,'(A)') '<values>'
          write(96,'(26g15.7)') TOUT
          write(96,'(A)') '</values>'
          write(96,'(A)') '</times>'

          write(96,'(A,I2,A)') '<theDose n="', IOUT, '" name="dose">'
          write(96,'(A)') '<values>'
          write(96,'(26g15.7)') (UU(ITIME,3,NRUN),ITIME=1,IOUT)
          write(96,'(A)') '</values>'
          write(96,'(A)') '</theDose>'


          write(96,'(A,I2,A)') '<z n="', IOUT, '" name="transformDose">'
          write(96,'(A)') '<values>'
          write(96,'(26g15.7)') (UU(ITIME,3,NRUN)**2,ITIME=1,IOUT)
          write(96,'(A)') '</values>'
          write(96,'(A)') '</z>'


      END DO   !END LOOP

c     --- XML ---
      write(96,'(A)') '</levele>'
      write(96,*)''


C === Close ===

      CLOSE(55)
      CLOSE(77)
      CLOSE(88)
      CLOSE(99)
      CLOSE(101)
      CLOSE(96)

       
       STOP
       END

c     End Of Program
