{
  //Create dataserver with the seed attribute
  TDataServer *tds = new TDataServer("foo","pouet");
  tds->addAttribute( new TUniformDistribution("seed",0,100000));
  tds->getAttribute("seed")->setFileKey("multitype_input.dat","", "%e",TAttributeFileKey::kNewRow);

  //Create DOE
  TSampling *tsam = new TSampling(tds,"lhs",100);
  tsam->generateSample();

  //Precise output and create Code
  TOutputFileKey *out = new TOutputFileKey("_output_multitype_mt_Key_condensate_.dat");
  out->addAttribute(new TAttribute("w1",TAttribute::kString));
  out->addAttribute(new TAttribute("w2",TAttribute::kString));
  out->addAttribute(new TAttribute("v1",TAttribute::kVector));
  out->addAttribute(new TAttribute("v2",TAttribute::kVector));
  out->addAttribute(new TAttribute("f1"));
  //Specify that the output will be separated by commas and that [ and ] have to be considered as separator (== ignored)
  out->setVectorProperties("[",",","]");
  
  TCode *myc = new URANIE::Launcher::TCode(tds, "multitype -mtKey");
  myc->addOutputFile( out );

  //Create TLauncher and run it
  TLauncher *tlau = new URANIE::Launcher::TLauncher(tds, myc);
  tlau->run();

  //Produce control plot
  TCanvas *Can = new TCanvas("Can","Can",10,10,1000,800);
  TPad *pad = new TPad("pad","pad",0, 0.03, 1, 1); pad->Draw(); pad->cd();
  tds->drawPairs("w1:v1:v2:f1:w2");
  
}
  