{
       
  // Create a TDataServer
  // Load a database in an ASCII file
  TDataServer * tds = new TDataServer("tdsFlowrate", "tds for flowrate");
  tds->fileDataRead("_flowrate_sampler_launcher_app_.dat");
    
  TCanvas *c = new TCanvas("c1", "Graph for the Macro modeler",5,64,1270,667);
  // Build a surrogate model (Artificial Neural Networks) from the PMML file
  TANNModeler* tann = new TANNModeler(tds, "uranie_ann_flowrate.pmml","ANNflowrate");
  
  // export the surrogate model in a C file
  tann->exportFunction("c++", "uranie_ann_flowrate_loaded","ANNflowrate");
  // load the surrogate model in the C file
  gROOT->LoadMacro("uranie_ann_flowrate_loaded.C");
 
  TDataServer * tdsv = new TDataServer("tdsv", "tds for surrogate model");
  tdsv->fileDataRead("_flowrate_sampler_launcher_val_.dat");
  
  cout << tdsv->getNPatterns() << endl;

  // evaluate the surrogate model on the database
  TLauncherFunction * tlf = new TLauncherFunction(tdsv, "ANNflowrate", "rw:r:tu:tl:hu:hl:l:kw", "yann");
  tlf->run();
    
  tdsv->startViewer();
  
  tdsv->Draw("yann:yhat");
  //  tdsv->draw("yhat");
   
}