{
   
  // Definition of the dataserver
  TDataServer * tds = new TDataServer();

  // Definition of the attributes
  TString sJDDReference = "input_rosenbrock_with_keys.dat";
  tds->addAttribute( new TAttribute("a", 0.0, 5.0));
  tds->getAttribute("a")->setFileKey(sJDDReference,"a");
  tds->getAttribute("a")->setDefaultValue(1.0);
  tds->getAttribute("a")->setStepValue(0.1);
  tds->addAttribute( new TAttribute("b", 0.0, 5.0));
  tds->getAttribute("b")->setFileKey(sJDDReference,"b");
  tds->getAttribute("b")->setDefaultValue(2.0);
  tds->getAttribute("b")->setStepValue(0.1);
  
  // Definition of the output file of the code
  TOutputFileRow *fout = new TOutputFileRow("_rosenbrock_multi_.dat");
  fout->addAttribute(new TAttribute("yhat"), 3);

  // OS abstraction
  string to_null =
    string(gSystem->GetBuildArch()) == "win64" ? " > NUL" : " >> /dev/null";
  
  // Definition of the code
  TCode *mycode = new TCode(tds, "root -b -l -q rosenbrock_multi.C" + to_null);
  mycode->addOutputFile(fout);
  mycode->addInputFile("rootlogon.C");
  mycode->addInputFile("rosenbrock_ref.dat");
  mycode->addInputFile("rosenbrock_multi.C");
  
  // Definition of the reference dataserver
  TDataServer *tdsref = new TDataServer("tdsref", "Objectives values");
  tdsref->fileDataRead("rosenbrock_ref.dat");
  
  // Definition of the optimizer
  TOptimizer *topt = new TOptimizer(tds, mycode);
  topt->addObjective("obj1", tdsref, "y", fout, "yhat");
  topt->optimize();
    
  TCanvas *c = new TCanvas();
  TPad *pad = new TPad("pad","pad",0, 0.03, 1, 1); pad->Draw();    
  tds->draw("b:a","","lp");
    
}