{
  //inputs
  TDataServer tds("foo","TDS for flowrate");
  tds.fileDataRead("readmultitype_sampling.dat");

  // Input attribute
  TAttribute *w1 = tds.getAttribute("w1");
  TAttribute *w2 = tds.getAttribute("w2");
  TAttribute *v1 = tds.getAttribute("v1");
  TAttribute *v2 = tds.getAttribute("v2");
  TAttribute *f1 = tds.getAttribute("f1");
          
  // output attribute
  TAttribute *thev1 = new TAttribute("thev1");
  TAttribute *thev2 = new TAttribute("thev2");
  gSystem->Exec("multitype -mtKey");
   // Create the output files
  TKeyScript inputFile("_output_multitype_mt_Key_condensate_.dat");
  inputFile.setInputs(5, w1, "w1", v1, "v1", v2, "v2", f1, "f1", w2, "w2");

  // Create the output files
  TKeyResult outputFile("_output_multitype_readmt_Key_.dat");
  outputFile.addOutput(thev1, "thev1");
  outputFile.addOutput(thev2, "thev2");

  // Create the user's evaluation function
  TCodeEval eval("multitype -ReadmtKey");
  eval.addInputFile(&inputFile);
  eval.addOutputFile(&outputFile);

  TSequentialRun runner(&eval);
  //TThreadedRun runner(&eval,2);
    
  runner.startSlave();                                           
  if (runner.onMaster())
    {      
      
      // Create the launcher
      TLauncher2 lanceur(&tds, &runner);
      lanceur.solverLoop();
        
      // Stop the slave processes
      runner.stopSlave();

    }

  tds.Scan("thev1:thev2");
  
}