{
  Int_t nS = 1000;
  // Define the DataServer
  TDataServer *tds = new TDataServer("tdsFlowrate", "Design of experiments for Flowrate");

  // Add the study attributes 
  tds->addAttribute( new TUniformDistribution("rw", 0.05, 0.15));
  tds->addAttribute( new TUniformDistribution("r", 100.0, 50000.0));
  tds->addAttribute( new TUniformDistribution("tu", 63070.0, 115600.0));
  tds->addAttribute( new TUniformDistribution("tl", 63.1, 116.0));
  tds->addAttribute( new TUniformDistribution("hu", 990.0, 1110.0));
  tds->addAttribute( new TUniformDistribution("hl", 700.0, 820.0));
  tds->addAttribute( new TUniformDistribution("l", 1120.0, 1680.0));
  tds->addAttribute( new TUniformDistribution("kw", 9855.0, 12045.0));

    
  // test Generateur de plan d'experience
  TSampling * sampling = new TSampling(tds, "lhs", nS);   
  sampling->generateSample();
  
  tds->exportData("_flowrate_sampler_.dat");

    
  // Visualisation
  TCanvas  *Canvas = new TCanvas("Canvas", "Graph for the Macro samplingFlowrate",5,64,1270,667);
  gStyle->SetPalette(1);
  TPad *pad = new TPad("pad","pad",0, 0.03, 1, 1); pad->Draw();
  
  pad->Divide(2, 2);
  pad->cd(1); tds->draw("r");
  pad->cd(2); tds->draw("rw");
  pad->cd(3); tds->drawTufte("rw:r");
  pad->cd(4); tds->draw("rw:r:hu");

      
}