"""
Example of SRC and SRRC estimation
"""
from rootlogon import ROOT, DataServer, Sensitivity

# Define the DataServer and fill it with datas in a file
tds = DataServer.TDataServer("tdsflowrate", "DataBase flowrate")
tds.fileDataRead("sampleLHSFlowrateModel4000points.dat")

# Create a TRegression object and compute indexes
treg = Sensitivity.TRegression(tds, "rw:r:tu:tl:hu:hl:l:kw",
                               "flowrateModel", "SRCSRRC")
treg.computeIndexes()

# Draw SRC Indexes
cc = ROOT.TCanvas("canpie-SRC", "Pie chart SRC", 10, 32, 1200, 800)
apad = ROOT.TPad("apad", "apad", 0, 0.03, 1, 1)
apad.Draw()
apad.cd()
treg.drawIndexes("Flowrate", "", "nonewcanv, pie, SRC")

# Draw SRRC Indexes
ccc = ROOT.TCanvas("canpie-SRRC", "Pie chart SRRC", 10, 32, 1200, 800)
pad2 = ROOT.TPad("pad2", "pad2", 0, 0.03, 1, 1)
pad2.Draw()
pad2.cd()
treg.drawIndexes("Flowrate", "", "nonewcanv,pie,SRRC")
