{
 // loading the flowrateModel function  
 gROOT->LoadMacro("UserFunctions.C");
	
 // Define the DataServer  and add the attributes (stochastic variables here)
 TDataServer *tds = new TDataServer("tdsflowreate", "DataBase flowreate");
 tds->addAttribute( new TUniformDistribution("rw", 0.05, 0.15));
 tds->addAttribute( new TUniformDistribution("r", 100.0, 50000.0));
 tds->addAttribute( new TUniformDistribution("tu", 63070.0, 115600.0));
 tds->addAttribute( new TUniformDistribution("tl", 63.1, 116.0));
 tds->addAttribute( new TUniformDistribution("hu", 990.0, 1110.0));
 tds->addAttribute( new TUniformDistribution("hl", 700.0, 820.0));
 tds->addAttribute( new TUniformDistribution("l", 1120.0, 1680.0));
 tds->addAttribute( new TUniformDistribution("kw", 9855.0, 12045.0)); 

 // Set nominal values
 tds->getAttribute("rw")->setDefaultValue(0.075);
 tds->getAttribute("r")->setDefaultValue(25000.0);
 tds->getAttribute("tu")->setDefaultValue(90000.0);
 tds->getAttribute("tl")->setDefaultValue(90.0);
 tds->getAttribute("hu")->setDefaultValue(1050.0);
 tds->getAttribute("hl")->setDefaultValue(760.0);
 tds->getAttribute("l")->setDefaultValue(1400.0);
 tds->getAttribute("kw")->setDefaultValue(10500.0);
 
 
 // Create a TFiniteDifferences object and compute indexes
 TFiniteDifferences * tfindef = new TFiniteDifferences(tds,"flowrateModel", "rw:r:tu:tl:hu:hl:l:kw", "y", "steps=0.5%"); 
 tfindef->computeIndexes();
 
 tfindef->getSensitivityMatrix().Print();
 
  }