/* --- Ansi C --- */
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2019 CEA/DEN
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   TEgoHjdynSolver.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date   2019-12-05
 
 \brief  hjma dynamic search for EI next point
*/

#ifndef __EGOHJDYNSOLVER__
#define __EGOHJDYNSOLVER__

// ROOT

// Uranie
#include "TDataServer.h"
#include "TRun.h"
//#include "TOptimFit.h"

//
#include "TEgoShareSolver.h"
//#include "THJMA.h"


namespace URANIE {
namespace MetaModelOptim {

class TEgoHjDynSolver : public TEgoHjSolver
{
protected :
    URANIE::Reoptimizer::TGreaterFit _signif;
    
    void fitnessChanged();
    void extend();

public :
    TEgoHjDynSolver();
    virtual ~TEgoHjDynSolver();

    void build(URANIE::Relauncher::TRun *,
        vector<URANIE::DataServer::TAttribute*>&, URANIE::DataServer::TAttribute *);
    
    ClassDef(URANIE::MetaModelOptim::TEgoHjDynSolver, ID_EGO)
};

} } // namespace

#endif

