/* --- Ansi C --- */
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2019 CEA/DEN
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   TEgoStdSolver.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date   2019-11-04
 
 \brief  recherche du point minimisant l'EI
*/

#ifndef __EGOBASICSOLVER__
#define __EGOBASICSOLVER__

// ROOT

// Uranie
#include "TDataServer.h"
#include "TRun.h"
#include "TVizirGenetic.h"
#include "TVizir2.h"
#include "TOptimFit.h"

#include "TEgoShareSolver.h"

namespace URANIE {
namespace MetaModelOptim {

class TEgoStdSolver : public TEgoVzrSolver
{
protected :
    int _Next;

    virtual void fitnessChanged();
    virtual void extend();
    
public :
    TEgoStdSolver();
    virtual ~TEgoStdSolver();

    void build(URANIE::Relauncher::TRun *,
        vector<URANIE::DataServer::TAttribute*>&, URANIE::DataServer::TAttribute *);
    virtual int getNext(long ev, int nb, 
        vector<vector<URANIE::DataServer::UEntry*>> &sampl, vector<char> &mark);

    ClassDef(URANIE::MetaModelOptim::TEgoStdSolver, ID_EGO)
};

} } //namespace

#endif
