//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2023 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////


#pragma link off all globals;
#pragma link off all classes;
#pragma link off all functions;

#pragma link C++ namespace URANIE::Modeler;

// ex Modeler
#pragma link C++ class URANIE::Modeler::TModeler+;
#pragma link C++ class URANIE::Modeler::TLinearRegression+;
#pragma link C++ class URANIE::Modeler::TPolynomialRegression+;
#pragma link C++ class URANIE::Modeler::TGLM+;
#pragma link C++ class URANIE::Modeler::TKernel+;
#pragma link C++ class URANIE::Modeler::TkPCA+;
#pragma link C++ class URANIE::Modeler::TkNN+;
#pragma link C++ class URANIE::Modeler::TPolynomialMultiDimFit+;

// MLP
// #pragma link C++ class TBootstrap+;

// ANN
#ifdef WITH_OPT
#pragma link C++ class URANIE::Modeler::TANNModeler+;
#endif

// NISP
#ifdef WITH_NISP
#pragma link C++ class URANIE::Modeler::TNisp+;
#pragma link C++ class URANIE::Modeler::TPolynomialChaos+;
#endif

// ANISP
#ifdef WITH_ANISP
#pragma link C++ class URANIE::Modeler::TAnisp+;
#endif

// PGauss
#ifdef WITH_PGAUSS
//#pragma link C++ class URANIE::Modeler::TGaussianProcess+;
#pragma link C++ class URANIE::Modeler::TGPBuilder+;
#pragma link C++ class URANIE::Modeler::TKriging+;
#pragma link C++ class URANIE::Modeler::TGPCostFunction+;
#pragma link C++ class URANIE::Modeler::TGPMLCostFunction+;
#pragma link C++ class URANIE::Modeler::TGPReMLCostFunction+;
#pragma link C++ class URANIE::Modeler::TGPLooCostFunction+;
#pragma link C++ class URANIE::Modeler::TCorrelationFunction+;
#pragma link C++ class URANIE::Modeler::TIsotropicGaussianCorrFunction+;
#pragma link C++ class URANIE::Modeler::TExponentialCorrFunction+;
#pragma link C++ class URANIE::Modeler::TGaussianCorrFunction+;
#pragma link C++ class URANIE::Modeler::TMaternICorrFunction+;
#pragma link C++ class URANIE::Modeler::TMaternIICorrFunction+; 
#pragma link C++ class URANIE::Modeler::TMaternIIICorrFunction+;
#pragma link C++ class URANIE::Modeler::TMatern12CorrFunction+;
#pragma link C++ class URANIE::Modeler::TMatern32CorrFunction+; 
#pragma link C++ class URANIE::Modeler::TMatern52CorrFunction+; 
#pragma link C++ class URANIE::Modeler::TMatern72CorrFunction+; 
#endif

// UMLP
#ifdef WITH_OPT
#pragma link C++ class URANIE::Modeler::UMLP+;
#pragma link C++ class URANIE::Modeler::USynapses+;
#endif

