/*//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2023 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "linpack_d.h"
#ifdef WIN32
#include "libpgauss_Export.h"
#else
#define libpgauss_EXPORT
#endif
/*
	VERIFIE 26/06/2012
*/
/* Calcul de des predictions - tendance deterministe constante  */
/* Methode gpPred1Bayes identique a gpPred1                     */
/* Input Kp : matrice new x n de covariances new x n		*/
/* Input variance : variance du processus		  	*/
/* Input hbeta : coefficient calcule par gpMod1Bayes (betapost) */
/* Input vbeta : variance de hbeta calcule par gpMod1Bayes (varpost) */
/* Input gamma : vecteur de taille n calcule par gpMOd1Bayes    */
/* Input iL : matrice n x n calcule par gpMOd1Bayes             */
/* Input new : nombre de ligne de Kp                   		*/
/* input n : nombre de colonnes de Kp et taille de gamma	*/
/* Output yp : vecteur des new predictions			*/
/* Output vp : vecteur des new variances			*/
libpgauss_EXPORT void gpPred1Bayes(double *Kp, double variance, double hbeta, double vbeta, double *gamma, double *iL, int new, int n, double *yp, double *vp) {
  void gpPred1(double *Kp, double variance, double hbeta, double vbeta, double *gamma, double *iL, int new, int n, double *yp, double *vp);
  gpPred1(Kp, variance, hbeta, vbeta, gamma, iL, new, n, yp, vp);
}
