//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2023 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////

#ifndef FCT_INTEG_ADAPTATIF_HPP
#define FCT_INTEG_ADAPTATIF_HPP

#include "SPC.hpp"
#include "util.hpp"
#include <vector>
#include <string>

namespace Anisp
{

void calcul_delta(double** Delta, int l); //construit le tableau des delta unidimensionnels uniforme

void calcul_delta_n(double** Delta, int l); //construit le tableau des delta unidimensionnels

void indices3(int** L, int* A, int d, int p);

void indices(int** J, int d);

void indices2(int**J, int d, int p, int i, int k);

bool inf(double a, double b);

bool inf1(double* a, double* b);

bool inf2(double* a, double* b);

bool inf3(double a[2], double b[2]);

bool inff(double* a, double* b);

double h(double* v, int d, int n);

//! search if ind belong to I
bool simple_search(int* ind, int** I, int m, int d);

//! search if ind belong to I
bool simple_vector_search(int* ind, vector<int*> I, int d);

// double fct_integ_adaptatif(double (*f)(double*),int d,int l,int m,double tol,char fich_quad[20],char fich_ind[20],int* ni);

// double fct_integ_adaptatif2(double (*f)(double*),int d,int l,int m,double tol,char fich_quad[20],char fich_ind[20],int* ni);//modifier la partie de compl�ment(fausse)

double CATP_carre(void (*f)(vector<double*>),
        void (*step_by_step)(double*, vector<int*>), int d, int l, int m,
        int max, double tol, int* ni, int* nld, vector<double*>* N,
        vector<double*>*H, vector<double*>* P, vector<int>* O, vector<int*>* V,
        vector<int>* S, int kmin, string loi, bool rep, bool log,
        string DataAnispFile, string ErrorIndicatorFile, string IndicesFile);

void ens_adm(int d, int l, int* X, int** I, vector<double*>* NN,
        vector<double*>* HH, vector<double*>* PP, double** Delta,
        double** Delta_n, string loi, int* nld, vector<int>* OO);

void sauvegarde_data(const char* data, int d, int n, int m, int* nld,
        vector<double*>* P, vector<double*>* H, vector<double*>* N,
        vector<int*>* V, vector<int>* S, vector<double*>* Ikmin, int* ni,
        int** I, double** G, double eta, double eta1, double r, int nkmin,
        int** Cq);

void recupere_data(const char* data, int d, int n, int m, int* nld,
        vector<double*>* P, vector<double*>* H, vector<double*>* N,
        vector<int*>* V, vector<int>* S, vector<double*>* Ikmin, int* ni,
        int** I, double** G, double* v, int* nkm, int** Cq);

}

#endif

