//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2023 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision$
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TestTCorrelationFunction.h
 \author Nicolas Gilardi <nicolas.gilardi@cea.fr>
 \date   $Date$
 
 \brief  Fichier de test de la classe URANIE::Modeler::TCorrelationFunction et de ses classes enfants.
 
 Cr�e le : 2012.11.16



 */
#ifndef CPPUNITEST_TCORRELATIONFUNCTION_H
#define CPPUNITEST_TCORRELATIONFUNCTION_H

#include <cppunit/extensions/HelperMacros.h>
//#include <cppunit/portability/CppUnitDeque.h>
#include <cppunit/Test.h>
#include <cppunit/TestFailure.h>
#include <cppunit/TestResultCollector.h>

/*! \class TCorrFunctionTest
 * \brief Unit tests for TCorrFunctionTest.
 */

class TCorrFunctionTest: public CPPUNIT_NS::TestFixture
{
    CPPUNIT_TEST_SUITE (TCorrFunctionTest);
    CPPUNIT_TEST (testTExponentialCorrFunction);
    CPPUNIT_TEST (testTGaussianCorrFunction);
    CPPUNIT_TEST (testTIsotropicGaussianCorrFunction);
    CPPUNIT_TEST (testTMaternICorrFunction);
    CPPUNIT_TEST (testTMaternIICorrFunction);
    CPPUNIT_TEST (testTMaternIIICorrFunction);
    CPPUNIT_TEST (testTMatern32CorrFunction);
    CPPUNIT_TEST (testTMatern52CorrFunction);
    CPPUNIT_TEST (testTMatern72CorrFunction);CPPUNIT_TEST_SUITE_END();

public:
    /*! Constructs a TCorrFunctionTest object.
     */
    TCorrFunctionTest();

    /// Destructor.
    virtual ~TCorrFunctionTest();

    double x1[3];
    double x2[3];
    double lc[3];

    void setUp();
    void tearDown();

    //---------------------------------------------
    /** @name Unit Tests
     The list of unit test
     **/
    //@{
    void testTExponentialCorrFunction();
    void testTGaussianCorrFunction();
    void testTIsotropicGaussianCorrFunction();
    void testTMaternICorrFunction();
    void testTMaternIICorrFunction();
    void testTMaternIIICorrFunction();
    void testTMatern32CorrFunction();
    void testTMatern52CorrFunction();
    void testTMatern72CorrFunction();

    //@}
};
#endif  //CPPUNITEST_TCORRELATIONFUNCTION_H

