//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2023 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision$
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TestTPolynomialMultiDimFit.h
 \author Fabrice Gaudier <fabrice.gaudier@cea.fr>
 \date   $Date$
 
 \brief  Fichier de test de la classe URANIE::DataServer::TPolynomialMultiDim
 
 Created the : 2012/08/24 15:45:24
 
 */
#ifndef CPPUNITEST_TestTPolynomialMultiDimFit_H
#define CPPUNITEST_TestTPolynomialMultiDimFit_H

#include <cppunit/extensions/HelperMacros.h>
//#include <cppunit/portability/CppUnitDeque.h>
#include <cppunit/Test.h>
#include <cppunit/TestFailure.h>
#include <cppunit/TestResultCollector.h>

#include "../TPolynomialMultiDimFit.h"

/*! \class TPolynomialMultiDimFitTest
 * \brief Unit tests for TPolynomialMultiDimFit.
 */
class TPolynomialMultiDimFitTest: public CPPUNIT_NS::TestFixture
{
    CPPUNIT_TEST_SUITE (TPolynomialMultiDimFitTest);
    CPPUNIT_TEST (testMDFIshigami);
    CPPUNIT_TEST (testConstructorUsingArchitecture);

    CPPUNIT_TEST (throwExceptionTPolynomialMultiDimFitConstructors);
    CPPUNIT_TEST (throwExceptionTPolynomialMultiDimFitSetterMethods);
    CPPUNIT_TEST (throwExceptionExportFunction);
    CPPUNIT_TEST_SUITE_END();

public:
    /*! Constructs a TPolynomialMultiDimFitTest object.
     */
    TPolynomialMultiDimFitTest();

    /// Destructor.
    virtual ~TPolynomialMultiDimFitTest();

    void setUp();
    void tearDown();
    
    //---------------------------------------------
    /** @name Unit Tests
     The list of unit test
     **/
    //@{
    void testMDFIshigami();
    //!  Unit test using the constructor with architecture
    void testConstructorUsingArchitecture();
    //@}

    //---------------------------------------------
    /** @name Exceptions
     The list of unit test of type throwException
     **/
    //@{
    //!Throw an exception in constructors
    void throwExceptionTPolynomialMultiDimFitConstructors();
    //!Throw an exectpion with setter attributs
    void throwExceptionTPolynomialMultiDimFitSetterMethods();
    //!Throw an exception if the language is not accpeted
    void throwExceptionExportFunction();
    //@}

private:
    URANIE::DataServer::TDataServer *tds1, *tds2;
};

#endif  // CPPUNITEST_TESTTLINEARREGRESSION_H
