//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2023 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision$
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TObjectiveL1.h
 \author Fabrice Gaudier <fabrice.gaudier@cea.fr>
 \date   fri jul 6 13:48:06 CEST 2007
 
 \brief Interface of class URANIE::Optimize::TObjectiveL1
 
 */
/**
 
 * @class URANIE::Optimizer::TObjectiveL1
 *
 * @brief Description of the class TObjectiveL1.
 *
 * To be written by the developper.
 *
 */
#ifndef TOBJECTIVEL1_H
#define TOBJECTIVEL1_H

#include <iostream>
using namespace std;

//ROOT

// Uranie
#include "TObjective.h"

namespace URANIE
{
namespace Optimizer
{
class TObjectiveL1: public TObjective
{
private:
public:
    //---------------------------------------------
    /** @name Constructor and Destructor
     **/
    //@{
    //! Constructor by name only
    /*! 
     
     \param name Name of the objective
     */
    TObjectiveL1(TString name);
    //! Default destructor
    virtual ~TObjectiveL1();
    //@}
    //---------------------------------------------
    /** @name Value of the Objective
     **/
    //@{
    Double_t getObjective(Double_t *dvalues, Int_t nrow);
    //@}

    //---------------------------------------------
    /** @name Printing Log
     **/
    //@{
    virtual void printLog(Option_t *option = "");
    //@}

    ClassDef(URANIE::Optimizer::TObjectiveL1, ID_OPTIMIZER)
    //Classe de
};

} // Fin du namespace Optimizer
} // Fin du namespace URANIE
#endif
