//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2023 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////

#pragma link off all globals;
#pragma link off all classes;
#pragma link off all functions;

#pragma link C++ namespace URANIE::Optimizer;

#pragma link C++ class URANIE::Optimizer::TOptimizer+;
#pragma link C++ class URANIE::Optimizer::TObjective+;
#pragma link C++ class URANIE::Optimizer::TObjectiveUncertainty+;
#pragma link C++ class URANIE::Optimizer::TObjectiveL1+;
#pragma link C++ class URANIE::Optimizer::TMultiGenAnalyticalFunction+;
#pragma link C++ class URANIE::Optimizer::TMultiGenCode+;
#pragma link C++ class URANIE::Optimizer::TMultiGenSumOfSquares+;
#pragma link C++ class URANIE::Optimizer::TBestEstimate+;

#ifdef WITH_OPT
#pragma link C++ class URANIE::Optimizer::TOptimizerOpt+;
#endif

#ifdef WITH_VIZIR
#pragma link C++ class URANIE::Optimizer::TVizir+;
// #pragma link C++ function vzrcint_class;
#endif

