//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2023 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
#ifndef CPPUNITEST_TOBJECTIVE_H
#define CPPUNITEST_TOBJECTIVE_H

#include <cppunit/extensions/HelperMacros.h>
//#include <cppunit/portability/CppUnitDeque.h>
#include <cppunit/Test.h>
#include <cppunit/TestFailure.h>
#include <cppunit/TestResultCollector.h>

// Uranie
#include "TObjective.h"
#include "TObjectiveL1.h"
#include "TObjectiveUncertainty.h"
#include "TDataServer.h"
#include "TLauncher.h"
#include "TAttribute.h"
#include "UExceptions.h"

class TObjectiveTest: public CPPUNIT_NS::TestFixture
{
    CPPUNIT_TEST_SUITE (TObjectiveTest);

    CPPUNIT_TEST (testTObjectiveConstructorObjective);
    CPPUNIT_TEST (testTObjectiveConstructorObjectiveL1);
    CPPUNIT_TEST (testTObjectiveConstructorObjectiveUncertainty);
    CPPUNIT_TEST (testTObjectivesetWeight);
    CPPUNIT_TEST (testTObjectiveunActive);
    CPPUNIT_TEST (testTObjectiveactive);
    CPPUNIT_TEST (testTObjectiveGetObjective);
    CPPUNIT_TEST (testTObjectiveUncertaintyGetObjective);
    CPPUNIT_TEST (testTObjectiveL1GetObjective);
    CPPUNIT_TEST (testTObjectiveSetLog);
    
    CPPUNIT_TEST_SUITE_END();

public:
    //---------------------------------------------
    /** @name Constructor and Destructor
     **/
    //@{
    //! Default constructor
    TObjectiveTest();

    //! Default destructor
    virtual ~TObjectiveTest();

    void setUp();
    void tearDown();

    //@}

    //---------------------------------------------
    /** @name Unit Tests
     The list of unit test
     **/
    //@{ 
    void testTObjectiveConstructorObjective();
    void testTObjectiveConstructorObjectiveL1();
    void testTObjectiveConstructorObjectiveUncertainty();
    void testTObjectivesetWeight();
    void testTObjectiveunActive();
    void testTObjectiveactive();
    void testTObjectiveGetObjective();
    void testTObjectiveUncertaintyGetObjective();
    void testTObjectiveL1GetObjective();
    void testTObjectiveSetLog();

    //@}

};

#endif  // CPPUNITEST_TOBJECTIVE_H
