//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2023 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
#ifndef CPPUNITEST_TOPTIMIZEROPT_H
#define CPPUNITEST_TOPTIMIZEROPT_H

#include <cppunit/extensions/HelperMacros.h>
//#include <cppunit/portability/CppUnitDeque.h>
#include <cppunit/Test.h>
#include <cppunit/TestFailure.h>
#include <cppunit/TestResultCollector.h>

// Uranie
#include "TOptimizerOpt.h"
#include "TDataServer.h"
#include "TLauncher.h"
#include "TAttribute.h"
#include "UExceptions.h"

using namespace URANIE::Optimizer;
using namespace URANIE::DataServer;

class TOptimizerOptTest: public CPPUNIT_NS::TestFixture
{
    CPPUNIT_TEST_SUITE (TOptimizerOptTest);
    CPPUNIT_TEST (testOptimizerOptConstructor);
    CPPUNIT_TEST (testOptimizerOptgetMethodCall);
    CPPUNIT_TEST (testOptimizerOptgetIteration);
    CPPUNIT_TEST (testTOptimizerOptSetLog);
    CPPUNIT_TEST (throwExceptionOptimizerOptConstructorTdsNull);
    CPPUNIT_TEST (throwExceptionOptimizerOptConstructorUnknowFunction);
    CPPUNIT_TEST (throwExceptionOptimizerOptConstructorUnknowLibrary);

    CPPUNIT_TEST_SUITE_END();

public:
    //---------------------------------------------
    /** @name Constructor and Destructor
     **/
    //@{
    //! Default constructor
    TOptimizerOptTest();

    //! Default destructor
    virtual ~TOptimizerOptTest();

    void setUp();
    void tearDown();
    //@}

    //---------------------------------------------
    /** @name Unit Tests
     The list of unit test
     **/
    //@{ 
    void testOptimizerOptConstructor();
    void testOptimizerOptgetMethodCall();
    void testOptimizerOptgetIteration();
    void testTOptimizerOptSetLog();
    void throwExceptionOptimizerOptConstructorTdsNull();
    void throwExceptionOptimizerOptConstructorUnknowFunction();
    void throwExceptionOptimizerOptConstructorUnknowLibrary();
    //@}

private:
    URANIE::DataServer::TDataServer *_tds;
    TOptimizerOpt * _topt;
};

#endif  // CPPUNITEST_TOPTIMIZEROPT_H
