//! The rosenbrock Function
/*!
 \$[ f(x_1, x_2) = a * ( x_2 - x_1^2 )^2 + b * ( 1.0 - x_1 )^2 \$]
 */
void rosenbrock(Double_t *x, Double_t *y)
{
    Double_t dx1 = x[0], dx2 = x[1];
    Double_t da = 10.0, db = 1.0;

    y[0] = da * (dx2 - dx1 * dx1) * (dx2 - dx1 * dx1)
            + db * (1.0 - dx1) * (1.0 - dx1);

}
