//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2023 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or any 
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision 1.3 $
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   vzr_multicontraint.c
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date    2008-03-28.12.07.02

 \brief classement specifique au multi critere avec contraintes
 */

#include "vzr_util.h"
#include "vzr_multi.h"

/** fonction du protocole **/
static double rang_individu(void *truc, struct vizir *viz, struct vzrwork *wviz)
{
    double ret, rsoft, rfun;

    rsoft = wviz->val[viz->rangdomi - 2] = (double) rang(viz, 0, viz->nbsoft);
    rfun = wviz->val[viz->rangdomi - 1] = (double) rang(viz, viz->nbsoft,
            viz->nbfun);
    ret = wviz->val[viz->rangdomi] = rsoft + rfun;
    //(double)rang(viz,viz->rangdomi-2, 2);
    return ret;
}

static void rang_population(void *truc, struct vizir *viz)
{
    int i;

    /* cas a valider */
    classe(viz, 0, viz->nbsoft, viz->rangdomi - 2);
    classe(viz, viz->nbsoft, viz->nbfun, viz->rangdomi - 1);
    for (i = 0; i < viz->N; i++)
        viz->pop_val[i][viz->rangdomi] = viz->pop_val[i][viz->rangdomi - 2]
                + viz->pop_val[i][viz->rangdomi - 1];
    //classe(viz, viz->rangdomi-2, 2, viz->rangdomi);
}

static int elite(void *truc, struct vizir *viz)
{
    int i, ret;

    ret = 0;
    for (i = 0; i < viz->N; i++)
        if (viz->pop_val[i][viz->rangdomi] == 0)
            ret++;
    return ret;
}

/** definition de l'instance de protocole **/

struct vzrclasse *multi_contraint2(void)
{
    static struct vzrclasse _multi_contraint =
    { (void *) NULL, 3, &rang_individu, &rang_population, &elite };
    return &_multi_contraint;
}

