//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2023 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or any 
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision 1.2 $
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TFormEval.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date    2012-09-21.11.03.36

 \brief fonction pour un problème form
 */

#ifndef __FORM_EVAL__
#define __FORM_EVAL__

#include "Reliability.h"
#include "TComposeEval.h"
#include "TSimpleTransform.h"
#include "TOptimShare.h"
#include "TOptimFit.h"

namespace URANIE
{
namespace Reliability
{

class TSorm;

class TFormEval: public URANIE::Relauncher::TComposeEval
{
protected:
    URANIE::DataServer::TAttribute *_valid;
    URANIE::Reoptimizer::TOptimFit *_fit;

public:
    class UnexpectedInput
    {
    };

    TFormEval(TSimpleTransform *, URANIE::Relauncher::TEval *);
    virtual ~TFormEval();

    void addConstraint(URANIE::DataServer::TAttribute *,
            URANIE::Reoptimizer::TOptimFit *fit = NULL);
    void addObjective(URANIE::Reoptimizer::TOptimShare *);
    void addLapse(TSorm*);

    virtual void freeze();

    ClassDef(URANIE::Reliability::TFormEval, ID_RELIABILITY)
};

}
} //namespace

#endif
