//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2023 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or any 
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision 1.2 $
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TSimpleTransform.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date    2012-04-02.11.36.18

 \brief FORM/SORM point de conception
 */

#ifndef __DESIGNpointEVAL__
#define __DESIGNpointEVAL__

#include "Reliability.h"
#include "TShareEval.h"

namespace URANIE
{
namespace Reliability
{

class TSimpleTransform: public URANIE::Relauncher::TShareEval
{
protected:
    TList _param;

public:
    TSimpleTransform();
    virtual ~TSimpleTransform();

    void addParameter(URANIE::DataServer::TAttribute *);
    void setParameters(Int_t, URANIE::DataServer::TAttribute *, ...);
    URANIE::DataServer::TAttribute * getBeta();

    virtual void freeze();
    virtual int eval(double *, double*, int=0);
    virtual int eval(vector<URANIE::DataServer::UEntry*> *, 
        vector<URANIE::DataServer::UEntry *>*, int=0);

    ClassDef(URANIE::Reliability::TSimpleTransform, ID_RELIABILITY)
};

}
} // namespace
#endif
