//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2023 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or any 
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision 1.2 $
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   ridder.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date    2012-07-12.11.21.06

 \brief Ridders root finding method
 */

#ifndef __RIDDER__
#define __RIDDER__

/* struct */
struct ridder
{
    double low, top, med, res;
    double flow, ftop, fmed;
    double eps;
    int etat, iter;
};

/* api */
#ifdef __cplusplus
extern "C"
{
#endif

struct ridder *create_ridder(double xl, double fl, double xt, double ft);
int ridder_first(struct ridder *self, double *nextx);
int ridder_next(struct ridder *self, double fold, double *nextx);
float ridder_result(struct ridder *self);
void ridder_clean(struct ridder *self);

#ifdef __cplusplus
}
#endif

#endif
