//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2023 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or any 
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision 1.2 $
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TVizirSimplex.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date    2012-02-10.06.52.47

 \brief algorithme inspiré du simplex de Nelder Mead
 */

#ifndef __TVIZIRSIMPLEX__
#define __TVIZIRSIMPLEX__

//ROOT
#include "Rtypes.h"

//URANIE
#include "Reoptimizer.h"
#include "TVizirSolver.h"

struct nms;

namespace URANIE
{
namespace Reoptimizer
{

class TVizirSimplex: public TVizirSolverShare
{
public:
    TVizirSimplex();
    virtual ~TVizirSimplex()
    {
    }

    // specific parameter

    //protocole
    virtual struct vzragent *build(int, int, int, double);

    ClassDef(URANIE::Reoptimizer::TVizirSimplex, ID_REOPTIMIZER);
};

}
} //namespace
#endif

