/* --- Ansi C --- */
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2020 CEA/DEN
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   nlopt_work.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date   2020-06-29
 
 \brief  undefined :-(
*/
#include "uranie_detection.h"
#ifdef Boost_COROUTINE_FOUND
#include <boost/coroutine2/all.hpp>

using namespace boost::coroutines2;
#endif

struct nlopt_work
{
    URANIE::Reoptimizer::TNloptShare *self;
    nlopt_opt solv, subsolv;
    double *guess, *last, *work, *grad, minf;
    vector<URANIE::DataServer::UEntry*> *codi, *codo, *codg;
    int id, state, noerr;
    Bool_t lastg;
#ifdef Boost_COROUTINE_FOUND
    coroutine<void>::push_type *yield;
#endif
};

