/* --- Ansi C --- */
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2003-2023 CEA/DES
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   vzr_util.h
 \author Michel DUMAS
 \date   2003-12-11
 
 \brief  macro interne pour vizir
*/


#ifndef __VZRUTIL__
#define __VZRUTIL__

#include "genetic/vzr_struct.h"

#include "vizir/vzr_macro.h"

#define DIMMODE 3 /* nb mode aternative */
#define VZRCLASS_MULTI   0 /* multi objectif */
#define VZRCLASS_MONO    3 /* mono objectif */
#define VZRCLASS_MONOC   7 /* mono objectif avec contraintes */
#define VZRCLASS_MULTIC  9 

#define VZRRUN_PEND    3
#define VZRRUN_RUN     1
#define VZRRUN_START   2
#define VZRRUN_STOP    4
#define VZRRUN_CONV    8
#define VZRRUN_END     16

#endif
