/* --- Ansi C --- */
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2015-2023 CEA/DES
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   nms_query.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date   2015-08-24
 
 \brief  Nelder Mead simplex api
*/

#ifndef __NMS_QUERY__
#define __NMS_QUERY__

#include "simplex/nms_struct.h"

#ifdef __cplusplus
extern "C" {
#endif

VZRLIB_EXPORT struct nms *nms_init(int nbin, int nbout, int nbcont, double prec);
VZRLIB_EXPORT int nms_prepare(struct nms *ret, int ant, int stop, int cyc);
VZRLIB_EXPORT int nms_build(struct nms *ret, int ant, int cyc, int stop);
VZRLIB_EXPORT int nms_resume(struct nms *ret, int max, char *nfile);
VZRLIB_EXPORT void nms_run(struct nms *self);
VZRLIB_EXPORT void nms_start(struct nms *self);
VZRLIB_EXPORT void nms_wait(struct nms *self);
VZRLIB_EXPORT int nms_running(struct nms *self);
VZRLIB_EXPORT void nms_dump(struct nms *self, char *nfile);
VZRLIB_EXPORT void nms_dealloc(struct nms *self);

#ifdef __cplusplus
} /* end of extern "C" */
#endif

#endif
