/* --- Ansi C --- */
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2010-2023 CEA/DES
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   vzr_config.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date   2010-02-17
 
 \brief  configuration
*/

#ifndef __VZR_CONFIG__
#define __VZR_CONFIG__

#include <pthread.h>
//extern void pthread_yield(void);

#define MPI_UNSAFE

/* #define COMBINATOIRE
 * */

#ifdef COMBINATOIRE
typedef int vzrgene_t;
#define MPI_GENE MPI_INT
#else
typedef double vzrgene_t;
#define MPI_GENE MPI_DOUBLE
#endif


#ifdef WIN32
#include <stdlib.h>
#include "vizir/vzr_dll.h"
#define INLINE __inline
#define VZRTAB_IN(typ, var) typ *var
#define VZRTAB_NEW(typ, var, siz) var = (typ *) calloc((siz), sizeof(typ))
#define VZRTAB(typ, var, siz) typ *var = (typ *) calloc((siz), sizeof(typ))
#define VZRTAB_OUT(var) free(var)

#else
#define VZRLIB_EXPORT
#define INLINE inline
#define VZRTAB_IN(typ, var)
#define VZRTAB_NEW(typ, var, siz) typ var[siz]
#define VZRTAB(typ, var, siz) typ var[siz]
#define VZRTAB_OUT(var)
#endif

#endif

