/* --- Ansi C --- */
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2013-2023 CEA/DES
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   vzr_heap.c
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date   2013-09-25
 
 \brief  sort avec un vecteur
*/

#include "vizir/vzr_config.h"

struct heap_comp {
    double *val;
};

static INLINE int hs_comp(struct heap_comp *hs, int i, int j)
{
    return (hs->val[i] < hs->val[j]);
}

#include "vizir/vzr_heapsort.h"

int vzr_rank_double(int size, int top, int *idx, double *val)
{
    struct heap_comp comp = {val};
    return hs_rank(idx, size, top, &comp);
}

