/* --- Ansi C --- */
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2010-2023 CEA/DES
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   vzr_heap2.c
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date   2010-04-14
 
 \brief  heapsort utilitaire
*/


#include "vizir/vzr_config.h"

#include "vizir/vzr_macro.h"
#include "vizir/vzritem.h"

/* utilitaires */
struct heap_comp {
    struct vzritem *val;
};

static INLINE int hs_comp(struct heap_comp *hs, int i, int j)
{
    //return (hs->val[i].rank < hs->val[j].rank);
    return (hs->val[i].rank < hs->val[j].rank ||
            ( 
                hs->val[i].rank == hs->val[j].rank &&
                hs->val[i].isol > hs->val[j].isol
            )
        );
}

#include "vizir/vzr_heapsort.h"

int vzr_rank_item(int size, int top, int *idx, struct vzritem *val)
{
    struct heap_comp comp = {val};
    return hs_rank(idx, size, top, &comp);
}

