/* --- Ansi C --- */
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2014-2023 CEA/DES
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   vzr_hypervol.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date   2014-05-19
 
 \brief  calcul de lindicateur dhyper-volume
*/

#ifndef __VZR_HYPERVOL__
#define __VZR_HYPERVOL__

#include "vizir/vzrpop_api.h"

/* structure */
/* 2D reference point */
struct ref2D {
    int id1, id2;
    double f1, f2;
};

/* 3D reference point */
struct ref3D {
    int id1, id2, id3;
    double f1, f2, f3;
};

/* private */
double hyper_surface(struct vzrpop *pop, struct ref2D *ref);
double hyper_volume(struct vzrpop *pop, struct ref3D *ref);

#endif
