/* --- Ansi C --- */
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2015-2023 CEA/DES
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   vzr_moga.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date   2015-08-21
 
 \brief  survie type moga nsga spea
*/


#ifndef __VZR_MOGA__
#define __VZR_MOGA__

#include "vizir/vzrpop_api.h"

int moga_viable(void *info, struct vzritem *it, struct vzrpop *self);
int spea_viable(void *info, struct vzritem *it, struct vzrpop *self);

void pareto_rank(void *info, int size, struct vzrpop *pop);
void pareto_egal_rank(void *info, int size, struct vzrpop *pop);
void spea_rank(void *info, int size, struct vzrpop *pop);

void pareto_survive(void *info, int size, int soon, struct vzrpop *self);

#endif
