/* --- Ansi C --- */
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2015-2023 CEA/DES
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   vzrfitness.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date   2015-08-21
 
 \brief  protocole pour l'evaluateur
*/

#ifndef __VZRFITNESS__
#define __VZRFITNESS__

#include "vizir/vzr_config.h"

/* protocole */
struct vzrfitness{
    void *data;
    int (*compute)(void *, vzrgene_t*, double*);
    void (*dealloc) (struct vzrfitness*);
};

struct vzrfitnessbuild {
    void *data;
    struct vzrfitness *(*create)(void *);
    void (*dealloc) (struct vzrfitnessbuild*);
};

typedef struct vzrfitness vzrfitness_t;
typedef struct vzrfitnessbuild vzrfitnessbuild_t;

#endif
