/* --- Ansi C --- */
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2013-2023 CEA/DES
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   vzritem.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date   2013-09-26
 
 \brief  manipulation des items
*/


#ifndef __VZRITEM__
#define __VZRITEM__

#include "vizir/vzr_config.h"
#include "vizir/vzr_macro.h"

/* structure */
typedef vzrgene_t *vzrallel_t;

struct vzrdiploid {
    vzrallel_t domin, reces;
};

struct vzritem {
    short flag, group;
    int rank, info, cycle;
    double isol; 
    double *front;
    void *data;
    union {
        vzrallel_t zone;
        struct vzrdiploid dip; /* acces */
    };
};
    
/* vzritem helpers */
#define APLOID 0
#define DIPLOID 1
#define MIGRED 2

#define APLOID_VAR(titi, pop) struct vzritem titi;\
    VZRTAB(vzrgene_t, titi ## zone, (pop)->gene);\
    VZRTAB(double, titi ## front, (pop)->all);\
    titi.flag = APLOID;\
    titi.zone = titi ## zone;\
    titi.front = titi ## front

#define DIPLOID_VAR(titi, pop) struct vzritem titi;\
    VZRTAB(vzrgene_t, titi ## zone, 2*(pop)->gene);\
    VZRTAB(double, titi ## front, (pop)->all);\
    titi.flag = DIPLOID;\
    titi.dip.domin = titi ## zone;\
    titi.dip.reces = titi ## zone+(pop)->gene;\
    titi.front = titi ## front

#define VAR_OUT(titi) VZRTAB_OUT(titi ## zone);\
    VZRTAB_OUT(titi ## front);

#endif
