/* --- Ansi C --- */
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2010-2023 CEA/DES
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   vzrtribe_api.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date   2010-12-15
 
 \brief  gestion des ilots via les threads
*/


#ifndef __VZRTRIBE__
#define __VZRTRIBE__

#include "vizir/vzragent_api.h"

/* structure */
struct vzrtribe {
    int size, gene;
    struct vzragent **ilot;
    struct vzrnetwork *migr;
};

/* public */

#ifdef __cplusplus
extern "C" {
#endif

VZRLIB_EXPORT struct vzrtribe *vzrtribe_create(int siz, struct vzragent **il);
VZRLIB_EXPORT void vzrtribe_migre(struct vzrtribe *self, int nid);
VZRLIB_EXPORT void vzrtribe_run(struct vzrtribe *self);
VZRLIB_EXPORT void vzrtribe_dealloc(struct vzrtribe *self);

#ifdef __cplusplus
} /* end of extern "C" */
#endif

#endif
