
using namespace URANIE::DataServer;
using namespace URANIE::Relauncher;
using namespace URANIE::Reoptimizer;

void funAllCost(Double_t *param, Double_t *res)
{
    Double_t x = param[0];
    Double_t y = param[1];
    res[0] = (x - 1.0) * (x - 1.0) + (y - 1.0) * (y - 1.0) + 1.0;
    res[1] = 1. / (x * x + y * y + 1.0);
}

void contHard1(double * paramt, Int_t *res)
{
    *res = 0;
    if (paramt[0] <= paramt[1] + 1.0)
        *res = 1;
}

void test_TVizirMulti()
{

    TAttribute x("x", 0.5, 2.0), y("y", 0.5, 1.0), c1("c1"), c2("c2");

    TCJitEval code(&funAllCost);
    code.setInputs(2, &x, &y);
    code.setOutputs(2, &c1, &c2);

    TDataServer tds("vizirDemo", "Param de l'opt vizir pour la barre");
    tds.addAttribute(&x);
    tds.addAttribute(&y);

    TVizirGenetic solv;
    solv.setSize(500, 100000);
    TVizir2 vzrmulti(&tds, &code, &solv);
    vzrmulti.addObjective(&c1);
    vzrmulti.addObjective(&c2);

    //vzrmulti.drawZoneAdmissible(0);
    //vzrmulti.drawImageZoneAdmissible();  

    /* resolution */
    vzrmulti.solverLoop();

    /* solution */
    //tds.drawTufte("x:y");
    tds.getTuple()->Scan("*");

    //tds.drawTufte("c1:c2");

}
