
/*
 #include <stdlib.h>
 #include <stdio.h>
 #include <math.h>

 #include "TDataServer.h"
 #include "TVizir2.h"

 #include "TTangramEval.cxx"
 */

using namespace URANIE::DataServer;
using namespace URANIE::Relauncher;
using namespace URANIE::Reoptimizer;

/* user defined */
#define TOLERANCE 0.001
#define NBmaxEVAL 50000
#define TAILLEPOP 250 
//#define TAILLEPOP 10 

#define NBGENE 7 // nombre de paramètres

/* solver */
void test_TVizirSeq()
{
    /* init */
    TAttribute z1("zone1", 0., 255.), z2("zone2", 0., 255.), z3("zone3", 0.,
            255.), z4("zone4", 0., 255.), z5("zone5", 0., 255.), z6("zone6", 0.,
            255.), z7("zone7", 0., 255.), ct("contrast");

    TTangramEval code;
    code.setInputs(NBGENE, &z1, &z2, &z3, &z4, &z5, &z6, &z7);
    code.addOutput(&ct);

    TDataServer tdsvzr("tdsvzr", "tds for vizir test");
    code.addAllInputs(&tdsvzr);

    TVizirGenetic solv;
    solv.setSurvivalRate(0.5);
    solv.setSize(TAILLEPOP, NBmaxEVAL);
    TVizir2 vzr(&tdsvzr, &code, &solv);
    vzr.setTolerance(TOLERANCE);
    TMaximizeFit maxim;
    vzr.addObjective(&ct, &maxim);

    /* resolution */
    vzr.solverLoop();

    //tdsvzr.getTuple()->Scan("*");
    tdsvzr.exportData("_sequen_.dat");

}
