/* --- Ansi C --- */
//////////////////////////////////////////////////////////////////////
// Copyright (C) 2013-2023 CEA/DES
// 
// This program is free software: you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation, either version 3 of
// the License, or any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public
// License along with this program. 
// if not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////////////
/*!
 \file   SamplerLinkDef.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date   2014-09-26
 
 \brief  root cint dictionary for sampler
*/

#pragma link off all globals;
#pragma link off all classes;
#pragma link off all functions;
#pragma link C++ nestedclasses;


#pragma link C++ namespace URANIE::Sampler;

// Kernel
#pragma link C++ class URANIE::Sampler::TSampler;
#pragma link C++ class URANIE::Sampler::TSamplerDeterminist;
#pragma link C++ class URANIE::Sampler::TSamplerStochastic;
#pragma link C++ class URANIE::Sampler::TSamplingMixture;

// Field
#pragma link C++ class URANIE::Sampler::TSamplerField;

// LatinHyperCube -> LHSSRS

// LHSInput -> LHSSRS

// LHSSRS
#pragma link C++ class LHSInput-;
#pragma link C++ class LHSVariable-;
#pragma link C++ class LHSNormal-;
#pragma link C++ class LHSLognormal-;
#pragma link C++ class LHSUniform-;
#pragma link C++ class LHSLoguniform-;
#pragma link C++ class LHSTriangular-;
#pragma link C++ class LHSLogtriangular-;
#pragma link C++ class LHSWeibull-;
#pragma link C++ class LHSConstant-;
#pragma link C++ class LHSUserDefined-;
#pragma link C++ class LatinHypercube;
#pragma link C++ class URANIE::Sampler::TSampling+;
#pragma link C++ class URANIE::Sampler::TGaussianSampling+;
#pragma link C++ class URANIE::Sampler::TBasicSampling+;
#pragma link C++ class URANIE::Sampler::TMaxiMinLHS+;
#pragma link C++ class URANIE::Sampler::TConstrLHS+;
#pragma link C++ class URANIE::Sampler::TImportanceSampling+;
#pragma link C++ class URANIE::Sampler::TOA+;
#pragma link C++ class URANIE::Sampler::TCopula;
#pragma link C++ class URANIE::Sampler::TEllipticalCopula;
#pragma link C++ class URANIE::Sampler::TGaussianCopula;
#pragma link C++ class URANIE::Sampler::TArchimedianCopula;
#pragma link C++ class URANIE::Sampler::TClaytonCopula;
#pragma link C++ class URANIE::Sampler::TFrankCopula;
#pragma link C++ class URANIE::Sampler::TPlackettCopula;
#pragma link C++ class URANIE::Sampler::TAMHCopula;
#pragma link C++ class URANIE::Sampler::TOATSampling+;
#pragma link C++ class URANIE::Sampler::TOATSamplingMultiNominal+; // deprecated
#pragma link C++ class URANIE::Sampler::TOATDesign+;

// MCMC
#pragma link C++ class TDistribution+;
#pragma link C++ class TMCMC+;
#pragma link C++ class TNormale+;
#pragma link C++ class TUniforme+;
#pragma link C++ class TMelange+;


// NISP
#pragma link C++ class URANIE::Sampler::TPetras;

// QMC
#pragma link C++ class URANIE::Sampler::TQMC;
#pragma link C++ class URANIE::Sampler::TSequence;
#pragma link C++ class URANIE::Sampler::THaltonSequence;
#pragma link C++ class URANIE::Sampler::TSobolSequence;
#pragma link C++ class URANIE::Sampler::TSpaceFilling;

// // RAFU
#ifdef WITH_SUNSET
#pragma link C++ class URANIE::Sampler::TRafuSampling;
#endif

// Copula

// VQ
#pragma link C++ class URANIE::Sampler::TVQ;
#pragma link C++ class URANIE::Sampler::TNeuralGas;

