//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2023 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
#ifndef CPPUNITEST_TDATASERVER_H
#define CPPUNITEST_TDATASERVER_H

#include <cppunit/extensions/HelperMacros.h>
//#include <cppunit/portability/CppUnitDeque.h>
#include <cppunit/Test.h>
#include <cppunit/TestFailure.h>
#include <cppunit/TestResultCollector.h>

// Uranie
#include "TSampler.h"
#include "TSampling.h"
#include "TQMC.h"
#include "TDataServer.h"
#include "UExceptions.h"

class TSamplerTest: public CPPUNIT_NS::TestFixture
{
    CPPUNIT_TEST_SUITE (TSamplerTest);
    CPPUNIT_TEST (testSampling);
    CPPUNIT_TEST (testSamplingWithSeed);
    CPPUNIT_TEST (testQMC);CPPUNIT_TEST_SUITE_END();

public:
    //---------------------------------------------
    /** @name Constructor and Destructor
     **/
    //@{
    //! Default constructor
    TSamplerTest();

    //! Default destructor
    virtual ~TSamplerTest();

    void setUp();
    void tearDown();
    //@}

    //---------------------------------------------
    /** @name Unit Tests
     The list of unit test
     **/
    //@{ 
    //! Test of the names
    void testSampling();
    //! Sampling Test with Seed
    void testSamplingWithSeed();
    //! Test of sampling with Sobol and Halton sequences
    void testQMC();
    //@}

private:
    URANIE::DataServer::TDataServer *_tds1;

};

#endif  // CPPUNITEST_TDATASERVER_H
