/////////////////////////////////////////////////////////////
// Copyright (C) 2013-2023 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TSensitivityTest.cxx
 \author Fabrice Gaudier <fabrice.gaudier@cea.fr>
 \date   ven oct 10 09:55:30 CEST 2008
 
 \brief Implementation of the class URANIE::Sensitivity::TSensitivityTest
 
 */

#include "TSensitivityTest.h"

ClassImp (URANIE::Sensitivity::TSensitivityTest)

namespace URANIE
{
namespace Sensitivity
{
TSensitivityTest::TSensitivityTest():
    TSensitivity()
{
    cout << " *** Default constrcutor TSensitivityTest (empty) ***" << endl;
}

TSensitivityTest::TSensitivityTest(URANIE::DataServer::TDataServer *tds,
        const char *varexpinput, const char *varexpoutput, Option_t * option) :
        TSensitivity(tds, varexpinput, varexpoutput, option)
{
}

TSensitivityTest::~TSensitivityTest()
{
    if ( _blog )
        cout << " *** destroy TSensitivityTest(" << GetName() << ") Title[" << GetTitle() << "] *** " << endl;
}

void TSensitivityTest::printLog(Option_t *option)
{
    cout << " ** TSensitivityTest::printLog[" << option << "]" << endl;
    cout << " ** Name[" << GetName() << "] Title[" << GetTitle() << "]" << endl;
    TSensitivity::printLog();
    cout << " ** End of TSensitivityTest::printLog[" << option << "]" << endl;
}

} // Fin du namespace Sensitivity
} // Fin du namespace URANIE

