string tab_hook(const string& input){
    vector<char> input_buffer(input.begin(), input.end());
    input_buffer.push_back('\0');
    int input_size = input.size();
    ostringstream hook;

    TTabCom tab;
    tab.Hook(input_buffer.data(), &input_size, hook);
    return hook.str();
}

vector<string> get_lines(const string& hooked) {
    istringstream input(hooked);
    vector<string> lines;
    string line;
    while (getline(input, line, '\n'))
        lines.push_back(line);
    return lines;
}

void write_completion(const string& filename, const string& input){
    auto types = get_lines(tab_hook(input));
    for(const auto& type: types)
        cout << "type: " << type << endl;
    auto types_json = TBufferJSON::ToJSON(&types);
    ofstream ouput(filename);
    ouput << types_json;
}
