//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2023 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published
// by the Free Software Foundation, either version 3 of the License, or any
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program. If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////

#pragma link off all globals;
#pragma link off all classes;
#pragma link off all functions;
#pragma link C++ nestedclasses;

#pragma link C++ namespace URANIE::Relauncher;

#pragma link C++ class URANIE::Relauncher::TMaster+;
#pragma link C++ class URANIE::Relauncher::TInformMaster+;
#pragma link C++ class URANIE::Relauncher::TLauncher2+;

#pragma link C++ class URANIE::Relauncher::TRun+;
#pragma link C++ class URANIE::Relauncher::TShareRun+;
#pragma link C++ class URANIE::Relauncher::TSimpleRun+;
#pragma link C++ class URANIE::Relauncher::TDecoratorRun+;
#pragma link C++ class URANIE::Relauncher::TSequentialRun+;
#pragma link C++ class URANIE::Relauncher::TThreadedRun+;
#pragma link C++ class URANIE::Relauncher::TSeparateRun+;
#pragma link C++ class URANIE::Relauncher::TSocketRun+;
#pragma link C++ class URANIE::Relauncher::TGradientEstimationRun+;

#pragma link C++ class URANIE::Relauncher::TEval+;
#pragma link C++ class URANIE::Relauncher::TStandardEval+;
#pragma link C++ class URANIE::Relauncher::TBaseEval+;
#pragma link C++ class URANIE::Relauncher::TShareEval+;
#pragma link C++ class URANIE::Relauncher::TSimpleEval+;
#pragma link C++ class URANIE::Relauncher::TDoubleEval+;
#pragma link C++ class URANIE::Relauncher::TCIntEval+;
#pragma link C++ class URANIE::Relauncher::TCJitEval+;
#pragma link C++ class URANIE::Relauncher::TComposeEval+;
#pragma link C++ class URANIE::Relauncher::TCodeBase+;
#pragma link C++ class URANIE::Relauncher::TCodeEval+;

#pragma link C++ class URANIE::Relauncher::TCodeScript+;
#pragma link C++ class URANIE::Relauncher::TShareScript+;
#pragma link C++ class URANIE::Relauncher::TVoidScript+;
#pragma link C++ class URANIE::Relauncher::TFlatScript+;
#pragma link C++ class URANIE::Relauncher::TLineScript+;
#pragma link C++ class URANIE::Relauncher::TKeyScript+;
#pragma link C++ class URANIE::Relauncher::TFlagScript+;
#pragma link C++ class URANIE::Relauncher::TCodeResult+;
#pragma link C++ class URANIE::Relauncher::TFlatResult+;
#pragma link C++ class URANIE::Relauncher::TLineResult+;
#pragma link C++ class URANIE::Relauncher::TKeyResult+;

#ifdef WITH_PYTHON
#pragma link C++ class URANIE::Relauncher::TPythonEval+;
#endif

#ifdef Boost_COROUTINE_FOUND
#pragma link C++ class URANIE::Relauncher::TCoroutineRun+;
#pragma link C++ class URANIE::Relauncher::TFakeEval+;
#pragma link C++ class URANIE::Relauncher::TComponentRun+;
#endif

#pragma link C++ class URANIE::Relauncher::TTangramEval+;


