//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2023 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or any 
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision 1.3 $
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TCIntEval.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date    2011-04-04.15.35.02

 \brief fonction C interprete
 */

#ifndef __TCINTEVAL__
#define __TCINTEVAL__

//ROOT
#include "Rtypes.h"
#include "TMethodCall.h"
#include "TString.h"

// Uranie
#include "Relauncher.h"
#include "TStandardEval.h"

namespace URANIE
{
namespace Relauncher
{

class TCIntEval: public TDoubleEval
{
protected:
    TMethodCall *_fun;
    void *_arg;
    Bool_t _ret;

public:
    TCIntEval(TString nfun, Bool_t h = kFALSE);
    TCIntEval(TString nfun, void *arg);
#ifdef ROOT5
    TCIntEval(void *fun, Bool_t h = kFALSE);
    TCIntEval(void *fun, void *arg);
#endif
    virtual ~TCIntEval();

    Int_t eval(Double_t *in, Double_t *out, int icalc);
    virtual bool isThreadSafe() {return false;}
    
    ClassDef(URANIE::Relauncher::TCIntEval, ID_RELAUNCHER)
};

}
}

#endif
