//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2023 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or any 
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision 1.1 $
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TCoroutineRun.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date    2012-12-18.11.51.11

 \brief execution recherche dans une coroutine
 */

#ifndef __TCOROUTINERUN__
#define __TCOROUTINERUN__

#include "TShareRun.h"

#include "uranie_detection.h"
#ifdef Boost_COROUTINE_FOUND
#include <boost/coroutine2/all.hpp>
using namespace boost::coroutines2;
#endif

namespace URANIE
{
namespace Relauncher
{

class TCoroutineRun: public TSimpleRun
{
protected:
    struct relement _next;
#ifdef Boost_COROUTINE_FOUND
    coroutine<void>::push_type *_yield;
#endif

public:
#ifdef Boost_COROUTINE_FOUND
    TCoroutineRun(TEval *, long, coroutine<void>::push_type *);
    TCoroutineRun(TEval *, long, void *);
#else
    TCoroutineRun(TEval *, long);
#endif
    virtual ~TCoroutineRun(void);

    virtual void startSlave(void);
    virtual void stopSlave(void);

    bool empty();
    struct element serviceGet();
    void servicePut(long, int);

    virtual int get(long &);

    ClassDef(URANIE::Relauncher::TCoroutineRun, ID_RELAUNCHER)
};

}
} //namespace

#endif
