//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2023 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or any 
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision 1.4 $
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TGradientEstimationRun.cxx
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date    2012-07-16.15.55.50

 \brief   run modifier with finite differencies gradient estimation
 */

#include "TGradientEstimationRun.h"

#include <math.h>

ClassImp (URANIE::Relauncher::TGradientEstimationRun);

#define EPS 1.0e-5
#define ZERO 1.e-20

namespace URANIE
{
namespace Relauncher
{

TGradientEstimationRun::TGradientEstimationRun(TRun *run) :
        TDecoratorRun(run)
{
    cout << "TGradientEstimationRun is useless, use sub runner directly\n";
}

TGradientEstimationRun::~TGradientEstimationRun(void)
{
    //delete _subrun;
}

void TGradientEstimationRun::put(long id, vector<URANIE::DataServer::UEntry*>*in, 
    vector<URANIE::DataServer::UEntry*> *out, int ncalc)
{
    _subrun->put(id, in, out, ncalc);
}

Bool_t TGradientEstimationRun::readyToGet()
{   
    return _subrun->readyToGet();
}

int TGradientEstimationRun::get(long &id)
{
    return _subrun->get(id);
}

}
} //namespace
