//////////////////////////////////////////////////////////////
// Copyright (C) 2013-2023 CEA/DES
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or any 
// later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.
//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////
// $Id$
// $Author$
// $Date$
// $Revision 1.2 $
// $State$
//////////////////////////////////////////////////////////////
/*!
 \file   TPythonEval.h
 \author Gilles ARNAUD <Gilles.Arnaud@cea.fr>
 \date    2012-02-21.15.56.38

 \brief utilisation dune fonction python dans pyROOT
 */

#ifndef __TPYTHONEVAL__
#define __TPYTHONEVAL__

//ROOT
#include "Rtypes.h"

//URANIE
#include "Relauncher.h"
#include "TStandardEval.h"

struct _object;

namespace URANIE
{
namespace Relauncher
{

class TPythonEval: public TSimpleEval
{
protected:
    struct _object *_fun;

public:
    TPythonEval(struct _object *);
    virtual ~TPythonEval();

    int eval(vector<URANIE::DataServer::UEntry*> *,vector<URANIE::DataServer::UEntry*> *, int =0 );

    //virtual bool isThreadSafe() {return false;}
    
    ClassDef(URANIE::Relauncher::TPythonEval, ID_RELAUNCHER)
};

}
} //namespace

#endif

