using namespace URANIE::DataServer;
using namespace URANIE::Sampler;
using namespace URANIE::Relauncher;

void test_TLauncherBidonSequential()
{
    // Add the study attributes ( min, max and nominal values)
    TUniformDistribution delai("delai", 0.0, 1.0), pente("pente", 0.8, 1.2);

    TAttribute x("x"), diff("diff");

    // Set the reference input file and the key for each input attributes
    TFlagScript fin("bidon.py");
    fin.addInput(&delai, "START");
    fin.addInput(&pente, "PENTE");

    // The output file of the code
    TFlatResult fout("bidon.res");
    fout.addOutput(&x);
    fout.addOutput(&diff);

    // Instanciation de mon code
    TCodeMulti mycode("python bidon.py > bidon.res");
    //     mycode.setWorkingDir(gSystem->Getenv("HOME") + TString("/tmp/"));
    mycode.addInputFile(&fin);
    mycode.addOutputFile(&fout);

    TSequentialRun run(&mycode);
    run.startSlave();
    if (run.onMaster())
    {
        TDataServer tds("tdsBidon", "Design of experiments for Bidon");
        tds.addAttribute(&delai);
        tds.addAttribute(&pente);

        TSampling sampling(&tds, "lhs", 50);
        sampling.generateSample();

        TLauncher2 lanceur(&tds, &run);

        /* resolution */
        lanceur.solverLoop();

        /* solution */
        tds.drawPairs();
//     tds.getTuple()->Scan("*");
        tds.exportData("_bidon_.dat");

        run.stopSlave();
    }
}
