#ifdef JIT
#include "TUniformDistribution.h"
#include "TDataServer.h"
#include "TSampling.h"
#endif

using namespace URANIE::DataServer;
using namespace URANIE::Sampler;

void test_TLauncherComposeSample()
{
    // Add the study attributes ( min, max and nominal values)
    TUniformDistribution coef("coef", 0.1, 1.0), 
            pente("pente", 0.4, 1.6);

    // Define the DataServer
    TDataServer tds("tdsBidon", "Design of experiments for Bidon");
    tds.addAttribute(&coef);
    tds.addAttribute(&pente);

    // sampling
    TSampling sampling(&tds, "lhs", 50);
    sampling.generateSample();
    tds.exportData("composeSample.dat");
    
}
