#include "Memory.h"

#include <stdio.h>
#include "stdlib.h"
#include "string.h"

int Memory::parseLine(char* line){
    // This assumes that a digit will be found and the line ends in " Kb".
    int i = strlen(line);
    const char* p = line;
    while (*p <'0' || *p > '9') p++;
    line[i-3] = '\0';
    i = atoi(p);
    return i;
}

#ifndef WIN32
int Memory::getVmValue(){ //Note: this value is in KB!
    FILE* file = fopen("/proc/self/status", "r");
    int result = -1;
    char line[128];

    while (fgets(line, 128, file) != NULL){
        if (strncmp(line, "VmSize:", 7) == 0){
            result = parseLine(line);
            break;
        }
    }
    fclose(file);
    return result;
}
#else
SIZE_T Memory::getVmValue(){ //Note: this value is in KB!

    PROCESS_MEMORY_COUNTERS_EX pmc;
    GetProcessMemoryInfo(GetCurrentProcess(), (PROCESS_MEMORY_COUNTERS*)&pmc, sizeof(pmc));
    SIZE_T virtualMemUsedByMe = pmc.PrivateUsage;

    return virtualMemUsedByMe;
}
#endif

void Memory::start()
{
    beginMemory = getVmValue();
}


void Memory::finish()
{
    endMemory = getVmValue();
    usedMemory = double(endMemory - beginMemory);
}


double Memory::elapsedMemory() const
{
  return usedMemory;
}
